"""Workflow version manaagement

Revision ID: 8288ee679937
Revises: d7994d35495b
Create Date: 2020-02-12 16:03:22.748828

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy import orm

# revision identifiers, used by Alembic.
revision = '8288ee679937'
down_revision = 'd7994d35495b'
branch_labels = None
depends_on = None


def upgrade():
    bind = op.get_bind()
    session = orm.Session(bind=bind)

    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('workflow',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('label', sa.VARCHAR(length=100), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('label')
    )
    op.add_column('state', sa.Column('workflow_id', sa.Integer(), nullable=True))
    op.create_foreign_key('fk_state_workflow_id_workflow', 'state', 'workflow', ['workflow_id'], ['id'])

    from studygovernor.models import Workflow, State
    default_workflow = Workflow(label='default')
    session.add(default_workflow)

    for state in session.query(State):
        state.workflow = default_workflow

    session.commit()

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('fk_state_workflow_id_workflow', 'state', type_='foreignkey')
    op.drop_column('state', 'workflow_id')
    op.drop_table('workflow')
    # ### end Alembic commands ###
